diff --git a/roms/ipxe/src/tests/settings_test.c b/roms/ipxe/src/tests/settings_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..028f8163b1502bbbd158eab48e3124c88c86ac22
--- /dev/null
+++ b/roms/ipxe/src/tests/settings_test.c
@@ -0,0 +1,278 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Settings self-tests
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <string.h>
+#include <ipxe/settings.h>
+#include <ipxe/test.h>
+
+/** Define inline raw data */
+#define RAW(...) { __VA_ARGS__ }
+
+/**
+ * Report a formatted-store test result
+ *
+ * @v settings		Settings block
+ * @v setting		Setting
+ * @v formatted		Formatted value
+ * @v raw_array		Expected raw value
+ */
+#define storef_ok( settings, setting, formatted, raw_array ) do {	\
+	const uint8_t expected[] = raw_array;				\
+	uint8_t actual[ sizeof ( expected ) ];				\
+	int len;							\
+									\
+	ok ( storef_setting ( settings, setting, formatted ) == 0 );	\
+	len = fetch_setting ( settings, setting, actual,		\
+			      sizeof ( actual ) );			\
+	DBGC ( settings, "Stored %s \"%s\", got:\n",			\
+	       (setting)->type->name, formatted );			\
+	DBGC_HDA ( settings, 0, actual, len );				\
+	ok ( len == ( int ) sizeof ( actual ) );			\
+	ok ( memcmp ( actual, expected, sizeof ( actual ) ) == 0 );	\
+	} while ( 0 )
+
+/**
+ * Report a formatted-fetch test result
+ *
+ * @v settings		Settings block
+ * @v setting		Setting
+ * @v raw_array		Raw value
+ * @v formatted		Expected formatted value
+ */
+#define fetchf_ok( settings, setting, raw_array, formatted ) do {	\
+	const uint8_t raw[] = raw_array;				\
+	char actual[ strlen ( formatted ) + 1 ];			\
+	int len;							\
+									\
+	ok ( store_setting ( settings, setting, raw,			\
+			     sizeof ( raw ) ) == 0 );			\
+	len = fetchf_setting ( settings, setting, actual,		\
+			       sizeof ( actual ) );			\
+	DBGC ( settings, "Fetched %s \"%s\" from:\n",			\
+	       (setting)->type->name, formatted );			\
+	DBGC_HDA ( settings, 0, raw, sizeof ( raw ) );			\
+	ok ( len == ( int ) ( sizeof ( actual ) - 1 ) );		\
+	ok ( strcmp ( actual, formatted ) == 0 );			\
+	} while ( 0 )
+
+/** Test generic settings block */
+struct generic_settings test_generic_settings = {
+	.settings = {
+		.refcnt = NULL,
+		.siblings =
+		    LIST_HEAD_INIT ( test_generic_settings.settings.siblings ),
+		.children =
+		    LIST_HEAD_INIT ( test_generic_settings.settings.children ),
+		.op = &generic_settings_operations,
+	},
+	.list = LIST_HEAD_INIT ( test_generic_settings.list ),
+};
+
+/** Test settings block */
+#define test_settings test_generic_settings.settings
+
+/** Test string setting */
+static struct setting test_string_setting = {
+	.name = "test_string",
+	.type = &setting_type_string,
+};
+
+/** Test URI-encoded string setting */
+static struct setting test_uristring_setting = {
+	.name = "test_uristring",
+	.type = &setting_type_uristring,
+};
+
+/** Test IPv4 address setting type */
+static struct setting test_ipv4_setting = {
+	.name = "test_ipv4",
+	.type = &setting_type_ipv4,
+};
+
+/** Test signed 8-bit integer setting type */
+static struct setting test_int8_setting = {
+	.name = "test_int8",
+	.type = &setting_type_int8,
+};
+
+/** Test signed 16-bit integer setting type */
+static struct setting test_int16_setting = {
+	.name = "test_int16",
+	.type = &setting_type_int16,
+};
+
+/** Test signed 32-bit integer setting type */
+static struct setting test_int32_setting = {
+	.name = "test_int32",
+	.type = &setting_type_int32,
+};
+
+/** Test unsigned 8-bit integer setting type */
+static struct setting test_uint8_setting = {
+	.name = "test_uint8",
+	.type = &setting_type_uint8,
+};
+
+/** Test unsigned 16-bit integer setting type */
+static struct setting test_uint16_setting = {
+	.name = "test_uint16",
+	.type = &setting_type_uint16,
+};
+
+/** Test unsigned 32-bit integer setting type */
+static struct setting test_uint32_setting = {
+	.name = "test_uint32",
+	.type = &setting_type_uint32,
+};
+
+/** Test colon-separated hex string setting type */
+static struct setting test_hex_setting = {
+	.name = "test_hex",
+	.type = &setting_type_hex,
+};
+
+/** Test hyphen-separated hex string setting type */
+static struct setting test_hexhyp_setting = {
+	.name = "test_hexhyp",
+	.type = &setting_type_hexhyp,
+};
+
+/** Test UUID setting type */
+static struct setting test_uuid_setting = {
+	.name = "test_uuid",
+	.type = &setting_type_uuid,
+};
+
+/**
+ * Perform settings self-tests
+ *
+ */
+static void settings_test_exec ( void ) {
+
+	/* Register test settings block */
+	ok ( register_settings ( &test_settings, NULL, "test" ) == 0 );
+
+	/* "string" setting type */
+	storef_ok ( &test_settings, &test_string_setting, "hello",
+		    RAW ( 'h', 'e', 'l', 'l', 'o' ) );
+	fetchf_ok ( &test_settings, &test_string_setting,
+		    RAW ( 'w', 'o', 'r', 'l', 'd' ), "world" );
+
+	/* "uristring" setting type */
+	storef_ok ( &test_settings, &test_uristring_setting, "hello%20world",
+		    RAW ( 'h', 'e', 'l', 'l', 'o', ' ', 'w', 'o', 'r', 'l',
+			  'd' ) );
+	fetchf_ok ( &test_settings, &test_uristring_setting,
+		    RAW ( 1, 2, 3, 4, 5 ), "%01%02%03%04%05" );
+
+	/* "ipv4" setting type */
+	storef_ok ( &test_settings, &test_ipv4_setting, "192.168.0.1",
+		    RAW ( 192, 168, 0, 1 ) );
+	fetchf_ok ( &test_settings, &test_ipv4_setting,
+		    RAW ( 212, 13, 204, 60 ), "212.13.204.60" );
+
+	/* Integer setting types */
+	storef_ok ( &test_settings, &test_int8_setting,
+		    "54", RAW ( 54 ) );
+	storef_ok ( &test_settings, &test_int8_setting,
+		    "0x7f", RAW ( 0x7f ) );
+	storef_ok ( &test_settings, &test_int8_setting,
+		    "0x1234", RAW ( 0x34 ) );
+	storef_ok ( &test_settings, &test_int8_setting,
+		    "-32", RAW ( -32 ) );
+	fetchf_ok ( &test_settings, &test_int8_setting,
+		    RAW ( -9 ), "-9" );
+	fetchf_ok ( &test_settings, &test_int8_setting,
+		    RAW ( 106 ), "106" );
+	storef_ok ( &test_settings, &test_uint8_setting,
+		    "129", RAW ( 129 ) );
+	storef_ok ( &test_settings, &test_uint8_setting,
+		    "0x3421", RAW ( 0x21 ) );
+	fetchf_ok ( &test_settings, &test_uint8_setting,
+		    RAW ( 0x54 ), "0x54" );
+	storef_ok ( &test_settings, &test_int16_setting,
+		    "29483", RAW ( 0x73, 0x2b ) );
+	fetchf_ok ( &test_settings, &test_int16_setting,
+		    RAW ( 0x82, 0x14 ), "-32236" );
+	fetchf_ok ( &test_settings, &test_int16_setting,
+		    RAW ( 0x12, 0x78 ), "4728" );
+	storef_ok ( &test_settings, &test_uint16_setting,
+		    "48727", RAW ( 0xbe, 0x57 ) );
+	fetchf_ok ( &test_settings, &test_uint16_setting,
+		    RAW ( 0x9a, 0x24 ), "0x9a24" );
+	storef_ok ( &test_settings, &test_int32_setting,
+		    "2901274", RAW ( 0x00, 0x2c, 0x45, 0x1a ) );
+	fetchf_ok ( &test_settings, &test_int32_setting,
+		    RAW ( 0xff, 0x34, 0x2d, 0xaf ), "-13357649" );
+	fetchf_ok ( &test_settings, &test_int32_setting,
+		    RAW ( 0x01, 0x00, 0x34, 0xab ), "16790699" );
+	storef_ok ( &test_settings, &test_uint32_setting,
+		    "0xb598d21", RAW ( 0x0b, 0x59, 0x8d, 0x21 ) );
+	fetchf_ok ( &test_settings, &test_uint32_setting,
+		    RAW ( 0xf2, 0x37, 0xb2, 0x18 ), "0xf237b218" );
+
+	/* "hex" setting type */
+	storef_ok ( &test_settings, &test_hex_setting,
+		    ":", RAW ( 0x00, 0x00 ) );
+	storef_ok ( &test_settings, &test_hex_setting,
+		    "1:2:", RAW ( 0x01, 0x02, 0x00 ) );
+	storef_ok ( &test_settings, &test_hex_setting,
+		    "08:12:f5:22:90:1b:4b:47:a8:30:cb:4d:67:4c:d6:76",
+		    RAW ( 0x08, 0x12, 0xf5, 0x22, 0x90, 0x1b, 0x4b, 0x47, 0xa8,
+			  0x30, 0xcb, 0x4d, 0x67, 0x4c, 0xd6, 0x76 ) );
+	fetchf_ok ( &test_settings, &test_hex_setting,
+		    RAW ( 0x62, 0xd9, 0xd4, 0xc4, 0x7e, 0x3b, 0x41, 0x46, 0x91,
+			  0xc6, 0xfd, 0x0c, 0xbf ),
+		    "62:d9:d4:c4:7e:3b:41:46:91:c6:fd:0c:bf" );
+
+	/* "hexhyp" setting type */
+	storef_ok ( &test_settings, &test_hexhyp_setting,
+		    "11-33-22", RAW ( 0x11, 0x33, 0x22 ) );
+	fetchf_ok ( &test_settings, &test_hexhyp_setting,
+		    RAW ( 0x9f, 0xe5, 0x6d, 0xfb, 0x24, 0x3a, 0x4c, 0xbb, 0xa9,
+			  0x09, 0x6c, 0x66, 0x13, 0xc1, 0xa8, 0xec, 0x27 ),
+		    "9f-e5-6d-fb-24-3a-4c-bb-a9-09-6c-66-13-c1-a8-ec-27" );
+
+	/* "uuid" setting type (no store capability) */
+	fetchf_ok ( &test_settings, &test_uuid_setting,
+		    RAW ( 0x1a, 0x6a, 0x74, 0x9d, 0x0e, 0xda, 0x46, 0x1a,0xa8,
+			  0x7a, 0x7c, 0xfe, 0x4f, 0xca, 0x4a, 0x57 ),
+		    "1a6a749d-0eda-461a-a87a-7cfe4fca4a57" );
+
+	/* Clear and unregister test settings block */
+	clear_settings ( &test_settings );
+	unregister_settings ( &test_settings );
+}
+
+/** Settings self-test */
+struct self_test settings_test __self_test = {
+	.name = "settings",
+	.exec = settings_test_exec,
+};
diff --git a/roms/ipxe/src/tests/sha1_test.c b/roms/ipxe/src/tests/sha1_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..bcf761bdd14f85bc6c667c949264a9ed0e7e139f
--- /dev/null
+++ b/roms/ipxe/src/tests/sha1_test.c
@@ -0,0 +1,105 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * SHA-1 tests
+ *
+ */
+
+#include <stdint.h>
+#include <ipxe/sha1.h>
+#include <ipxe/test.h>
+#include "digest_test.h"
+
+/** An SHA-1 test vector */
+struct sha1_test_vector {
+	/** Test data */
+	void *data;
+	/** Test data length */
+	size_t len;
+	/** Expected digest */
+	uint8_t digest[SHA1_DIGEST_SIZE];
+};
+
+/** SHA-1 test vectors */
+static struct sha1_test_vector sha1_test_vectors[] = {
+	/* Empty test data
+	 *
+	 * Expected digest value obtained from "sha1sum /dev/null"
+	 */
+	{ NULL, 0,
+	  { 0xda, 0x39, 0xa3, 0xee, 0x5e, 0x6b, 0x4b, 0x0d, 0x32, 0x55,
+	    0xbf, 0xef, 0x95, 0x60, 0x18, 0x90, 0xaf, 0xd8, 0x07, 0x09 } },
+	/* Test data and expected digests taken from the NIST
+	 * Cryptographic Toolkit Algorithm Examples at
+	 * http://csrc.nist.gov/groups/ST/toolkit/documents/Examples/SHA1.pdf
+	 */
+	{ "abc", 3,
+	  { 0xa9, 0x99, 0x3e, 0x36, 0x47, 0x06, 0x81, 0x6a, 0xba, 0x3e,
+	    0x25, 0x71, 0x78, 0x50, 0xc2, 0x6c, 0x9c, 0xd0, 0xd8, 0x9d } },
+	{ "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq", 56,
+	  { 0x84, 0x98, 0x3e, 0x44, 0x1c, 0x3b, 0xd2, 0x6e, 0xba, 0xae,
+	    0x4a, 0xa1, 0xf9, 0x51, 0x29, 0xe5, 0xe5, 0x46, 0x70, 0xf1 } },
+};
+
+/** SHA-1 test fragment lists */
+static struct digest_test_fragments sha1_test_fragments[] = {
+	{ { 0, -1UL, } },
+	{ { 1, 1, 1, 1, 1, 1, 1, 1 } },
+	{ { 2, 0, 23, 4, 6, 1, 0 } },
+};
+
+/**
+ * Perform SHA-1 self-test
+ *
+ */
+static void sha1_test_exec ( void ) {
+	struct digest_algorithm *digest = &sha1_algorithm;
+	struct sha1_test_vector *test;
+	unsigned long cost;
+	unsigned int i;
+	unsigned int j;
+
+	/* Correctness test */
+	for ( i = 0 ; i < ( sizeof ( sha1_test_vectors ) /
+			    sizeof ( sha1_test_vectors[0] ) ) ; i++ ) {
+		test = &sha1_test_vectors[i];
+		/* Test with a single pass */
+		digest_ok ( digest, NULL, test->data, test->len, test->digest );
+		/* Test with fragment lists */
+		for ( j = 0 ; j < ( sizeof ( sha1_test_fragments ) /
+				    sizeof ( sha1_test_fragments[0] ) ) ; j++ ){
+			digest_ok ( digest, &sha1_test_fragments[j],
+				    test->data, test->len, test->digest );
+		}
+	}
+
+	/* Speed test */
+	cost = digest_cost ( digest );
+	DBG ( "SHA1 required %ld cycles per byte\n", cost );
+}
+
+/** SHA-1 self-test */
+struct self_test sha1_test __self_test = {
+	.name = "sha1",
+	.exec = sha1_test_exec,
+};
diff --git a/roms/ipxe/src/tests/sha256_test.c b/roms/ipxe/src/tests/sha256_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..06a8cae25e62014e041c90eb5ebcecb2b10f9ecf
--- /dev/null
+++ b/roms/ipxe/src/tests/sha256_test.c
@@ -0,0 +1,108 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * SHA-256 tests
+ *
+ */
+
+#include <stdint.h>
+#include <ipxe/sha256.h>
+#include <ipxe/test.h>
+#include "digest_test.h"
+
+/** An SHA-256 test vector */
+struct sha256_test_vector {
+	/** Test data */
+	void *data;
+	/** Test data length */
+	size_t len;
+	/** Expected digest */
+	uint8_t digest[SHA256_DIGEST_SIZE];
+};
+
+/** SHA-256 test vectors */
+static struct sha256_test_vector sha256_test_vectors[] = {
+	/* Empty test data
+	 *
+	 * Expected digest value obtained from "sha256sum /dev/null"
+	 */
+	{ NULL, 0,
+	  { 0xe3, 0xb0, 0xc4, 0x42, 0x98, 0xfc, 0x1c, 0x14, 0x9a, 0xfb, 0xf4,
+	    0xc8, 0x99, 0x6f, 0xb9, 0x24, 0x27, 0xae, 0x41, 0xe4, 0x64, 0x9b,
+	    0x93, 0x4c, 0xa4, 0x95, 0x99, 0x1b, 0x78, 0x52, 0xb8, 0x55 } },
+	/* Test data and expected digests taken from the NIST
+	 * Cryptographic Toolkit Algorithm Examples at
+	 * http://csrc.nist.gov/groups/ST/toolkit/documents/Examples/SHA256.pdf
+	 */
+	{ "abc", 3,
+	  { 0xba, 0x78, 0x16, 0xbf, 0x8f, 0x01, 0xcf, 0xea, 0x41, 0x41, 0x40,
+	    0xde, 0x5d, 0xae, 0x22, 0x23, 0xb0, 0x03, 0x61, 0xa3, 0x96, 0x17,
+	    0x7a, 0x9c, 0xb4, 0x10, 0xff, 0x61, 0xf2, 0x00, 0x15, 0xad } },
+	{ "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq", 56,
+	  { 0x24, 0x8d, 0x6a, 0x61, 0xd2, 0x06, 0x38, 0xb8, 0xe5, 0xc0, 0x26,
+	    0x93, 0x0c, 0x3e, 0x60, 0x39, 0xa3, 0x3c, 0xe4, 0x59, 0x64, 0xff,
+	    0x21, 0x67, 0xf6, 0xec, 0xed, 0xd4, 0x19, 0xdb, 0x06, 0xc1 } },
+};
+
+/** SHA-256 test fragment lists */
+static struct digest_test_fragments sha256_test_fragments[] = {
+	{ { 0, -1UL, } },
+	{ { 1, 1, 1, 1, 1, 1, 1, 1 } },
+	{ { 2, 0, 23, 4, 6, 1, 0 } },
+};
+
+/**
+ * Perform SHA-256 self-test
+ *
+ */
+static void sha256_test_exec ( void ) {
+	struct digest_algorithm *digest = &sha256_algorithm;
+	struct sha256_test_vector *test;
+	unsigned long cost;
+	unsigned int i;
+	unsigned int j;
+
+	/* Correctness test */
+	for ( i = 0 ; i < ( sizeof ( sha256_test_vectors ) /
+			    sizeof ( sha256_test_vectors[0] ) ) ; i++ ) {
+		test = &sha256_test_vectors[i];
+		/* Test with a single pass */
+		digest_ok ( digest, NULL, test->data, test->len, test->digest );
+		/* Test with fragment lists */
+		for ( j = 0 ; j < ( sizeof ( sha256_test_fragments ) /
+				    sizeof ( sha256_test_fragments[0] )); j++ ){
+			digest_ok ( digest, &sha256_test_fragments[j],
+				    test->data, test->len, test->digest );
+		}
+	}
+
+	/* Speed test */
+	cost = digest_cost ( digest );
+	DBG ( "SHA256 required %ld cycles per byte\n", cost );
+}
+
+/** SHA-256 self-test */
+struct self_test sha256_test __self_test = {
+	.name = "sha256",
+	.exec = sha256_test_exec,
+};
diff --git a/roms/ipxe/src/tests/string_test.c b/roms/ipxe/src/tests/string_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..88181cc21796db40473f561a76e57c06481cf1a1
--- /dev/null
+++ b/roms/ipxe/src/tests/string_test.c
@@ -0,0 +1,133 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * String self-tests
+ *
+ * memcpy() tests are handled separately
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ipxe/test.h>
+
+/**
+ * Perform string self-tests
+ *
+ */
+static void string_test_exec ( void ) {
+
+	/* Test strlen() */
+	ok ( strlen ( "" ) == 0 );
+	ok ( strlen ( "Hello" ) == 5 );
+	ok ( strlen ( "Hello world!" ) == 12 );
+	ok ( strlen ( "Hello\0world!" ) == 5 );
+
+	/* Test strnlen() */
+	ok ( strnlen ( "", 0 ) == 0 );
+	ok ( strnlen ( "", 10 ) == 0 );
+	ok ( strnlen ( "Hello", 0 ) == 0 );
+	ok ( strnlen ( "Hello", 3 ) == 3 );
+	ok ( strnlen ( "Hello", 5 ) == 5 );
+	ok ( strnlen ( "Hello", 16 ) == 5 );
+	ok ( strnlen ( "Hello world!", 5 ) == 5 );
+	ok ( strnlen ( "Hello world!", 11 ) == 11 );
+	ok ( strnlen ( "Hello world!", 16 ) == 12 );
+
+	/* Test strchr() */
+	ok ( strchr ( "", 'a' ) == NULL );
+	ok ( *(strchr ( "Testing", 'e' )) == 'e' );
+	ok ( *(strchr ( "Testing", 'g' )) == 'g' );
+	ok ( strchr ( "Testing", 'x' ) == NULL );
+
+	/* Test strcmp() */
+	ok ( strcmp ( "", "" ) == 0 );
+	ok ( strcmp ( "Hello", "Hello" ) == 0 );
+	ok ( strcmp ( "Hello", "hello" ) != 0 );
+	ok ( strcmp ( "Hello", "Hello world!" ) != 0 );
+	ok ( strcmp ( "Hello world!", "Hello" ) != 0 );
+
+	/* Test strncmp() */
+	ok ( strncmp ( "", "", 0 ) == 0 );
+	ok ( strncmp ( "", "", 15 ) == 0 );
+	ok ( strncmp ( "Goodbye", "Goodbye", 16 ) == 0 );
+	ok ( strncmp ( "Goodbye", "Hello", 16 ) != 0 );
+	ok ( strncmp ( "Goodbye", "Goodbye world", 32 ) != 0 );
+	ok ( strncmp ( "Goodbye", "Goodbye world", 7 ) == 0 );
+
+	/* Test memcmp() */
+	ok ( memcmp ( "", "", 0 ) == 0 );
+	ok ( memcmp ( "Foo", "Foo", 3 ) == 0 );
+	ok ( memcmp ( "Foo", "Bar", 3 ) != 0 );
+
+	/* Test memset() */
+	{
+		static uint8_t test[7] = { '>', 1, 1, 1, 1, 1, '<' };
+		static const uint8_t expected[7] = { '>', 0, 0, 0, 0, 0, '<' };
+		memset ( ( test + 1 ), 0, ( sizeof ( test ) - 2 ) );
+		ok ( memcmp ( test, expected, sizeof ( test ) ) == 0 );
+	}
+	{
+		static uint8_t test[4] = { '>', 0, 0, '<' };
+		static const uint8_t expected[4] = { '>', 0xeb, 0xeb, '<' };
+		memset ( ( test + 1 ), 0xeb, ( sizeof ( test ) - 2 ) );
+		ok ( memcmp ( test, expected, sizeof ( test ) ) == 0 );
+	}
+
+	/* Test memmove() */
+	{
+		static uint8_t test[11] =
+			{ '>', 1, 2, 3, 4, 5, 6, 7, 8, 9, '<' };
+		static const uint8_t expected[11] =
+			{ '>', 3, 4, 5, 6, 7, 8, 7, 8, 9, '<' };
+		memmove ( ( test + 1 ), ( test + 3 ), 6 );
+		ok ( memcmp ( test, expected, sizeof ( test ) ) == 0 );
+	}
+	{
+		static uint8_t test[12] =
+			{ '>', 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, '<' };
+		static const uint8_t expected[12] =
+			{ '>', 1, 2, 3, 4, 5, 1, 2, 3, 4, 5, '<' };
+		memmove ( ( test + 6 ), ( test + 1 ), 5 );
+		ok ( memcmp ( test, expected, sizeof ( test ) ) == 0 );
+	}
+
+	/* Test memswap() */
+	{
+		static uint8_t test[8] =
+			{ '>', 1, 2, 3, 7, 8, 9, '<' };
+		static const uint8_t expected[8] =
+			{ '>', 7, 8, 9, 1, 2, 3, '<' };
+		memswap ( ( test + 1 ), ( test + 4 ), 3 );
+		ok ( memcmp ( test, expected, sizeof ( test ) ) == 0 );
+	}
+}
+
+/** String self-test */
+struct self_test string_test __self_test = {
+	.name = "string",
+	.exec = string_test_exec,
+};
diff --git a/roms/ipxe/src/tests/tcpip_test.c b/roms/ipxe/src/tests/tcpip_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..13423c397cf60eb6faa14aa15ac5d1770ed39f32
--- /dev/null
+++ b/roms/ipxe/src/tests/tcpip_test.c
@@ -0,0 +1,213 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * TCP/IP self-tests
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <assert.h>
+#include <ipxe/test.h>
+#include <ipxe/profile.h>
+#include <ipxe/tcpip.h>
+
+/** A TCP/IP fixed-data test */
+struct tcpip_test {
+	/** Data */
+	const void *data;
+	/** Length of data */
+	size_t len;
+};
+
+/** A TCP/IP pseudorandom-data test */
+struct tcpip_random_test {
+	/** Seed */
+	unsigned int seed;
+	/** Length of data */
+	size_t len;
+	/** Alignment offset */
+	size_t offset;
+};
+
+/** Define inline data */
+#define DATA(...) { __VA_ARGS__ }
+
+/** Define a TCP/IP fixed-data test */
+#define TCPIP_TEST( name, DATA )					\
+	static const uint8_t __attribute__ (( aligned ( 16 ) ))		\
+		name ## _data[] = DATA;					\
+	static struct tcpip_test name = {				\
+		.data = name ## _data,					\
+		.len = sizeof ( name ## _data ),			\
+	}
+
+/** Define a TCP/IP pseudorandom-data test */
+#define TCPIP_RANDOM_TEST( name, SEED, LEN, OFFSET )			\
+	static struct tcpip_random_test name = {			\
+		.seed = SEED,						\
+		.len = LEN,						\
+		.offset = OFFSET,					\
+	}
+
+/** Buffer for pseudorandom-data tests */
+static uint8_t __attribute__ (( aligned ( 16 ) ))
+	tcpip_data[ 4096 + 7 /* offset */ ];
+
+/** Empty data */
+TCPIP_TEST ( empty, DATA() );
+
+/** Single byte */
+TCPIP_TEST ( one_byte, DATA ( 0xeb ) );
+
+/** Double byte */
+TCPIP_TEST ( two_bytes, DATA ( 0xba, 0xbe ) );
+
+/** Final wrap-around carry (big-endian) */
+TCPIP_TEST ( final_carry_big,
+	     DATA ( 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01 ) );
+
+/** Final wrap-around carry (little-endian) */
+TCPIP_TEST ( final_carry_little,
+	     DATA ( 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00 ) );
+
+/** Random data (aligned) */
+TCPIP_RANDOM_TEST ( random_aligned, 0x12345678UL, 4096, 0 );
+
+/** Random data (unaligned, +1) */
+TCPIP_RANDOM_TEST ( random_unaligned_1, 0x12345678UL, 4096, 1 );
+
+/** Random data (unaligned, +2) */
+TCPIP_RANDOM_TEST ( random_unaligned_2, 0x12345678UL, 4096, 2 );
+
+/** Random data (aligned, truncated) */
+TCPIP_RANDOM_TEST ( random_aligned_truncated, 0x12345678UL, 4095, 0 );
+
+/** Random data (unaligned start and finish) */
+TCPIP_RANDOM_TEST ( partial, 0xcafebabe, 121, 5 );
+
+/**
+ * Calculate TCP/IP checksum
+ *
+ * @v data		Data to sum
+ * @v len		Length of data
+ * @ret cksum		Checksum
+ *
+ * This is a reference implementation taken from RFC1071 (and modified
+ * to fix compilation without warnings under gcc).
+ */
+static uint16_t rfc_tcpip_chksum ( const void *data, size_t len ) {
+	unsigned long sum = 0;
+
+        while ( len > 1 )  {
+		sum += *( ( uint16_t * ) data );
+		data += 2;
+		len -= 2;
+	}
+
+	if ( len > 0 )
+		sum += *( ( uint8_t * ) data );
+
+	while ( sum >> 16 )
+		sum = ( ( sum & 0xffff ) + ( sum >> 16 ) );
+
+	return ~sum;
+}
+
+/**
+ * Report TCP/IP fixed-data test result
+ *
+ * @v test		TCP/IP test
+ */
+#define tcpip_ok( test ) do {						\
+	uint16_t expected;						\
+	uint16_t generic_sum;						\
+	uint16_t sum;							\
+	expected = rfc_tcpip_chksum ( (test)->data, (test)->len );	\
+	generic_sum = generic_tcpip_continue_chksum ( TCPIP_EMPTY_CSUM,	\
+						      (test)->data,	\
+						      (test)->len );	\
+	ok ( generic_sum == expected );					\
+	sum = tcpip_continue_chksum ( TCPIP_EMPTY_CSUM, (test)->data,	\
+				      (test)->len );			\
+	ok ( sum == expected );						\
+	} while ( 0 )
+
+/**
+ * Report TCP/IP pseudorandom-data test result
+ *
+ * @v test		TCP/IP test
+ */
+#define tcpip_random_ok( test ) do {					\
+	uint8_t *data = ( tcpip_data + (test)->offset );		\
+	uint16_t expected;						\
+	uint16_t generic_sum;						\
+	uint16_t sum;							\
+	unsigned long elapsed;						\
+	unsigned int i;							\
+	assert ( ( (test)->len + (test)->offset ) <=			\
+		 sizeof ( tcpip_data ) );				\
+	srandom ( (test)->seed );					\
+	for ( i = 0 ; i < (test)->len ; i++ )				\
+		data[i] = random();					\
+	expected = rfc_tcpip_chksum ( data, (test)->len );		\
+	generic_sum = generic_tcpip_continue_chksum ( TCPIP_EMPTY_CSUM,	\
+						      data,		\
+						      (test)->len );	\
+	ok ( generic_sum == expected );					\
+	simple_profile();						\
+	sum = tcpip_continue_chksum ( TCPIP_EMPTY_CSUM, data,		\
+				      (test)->len );			\
+	elapsed = simple_profile();					\
+	ok ( sum == expected );						\
+	DBG ( "TCPIP checksummed %zd bytes (+%zd) in %ld ticks\n",	\
+	      (test)->len, (test)->offset, elapsed );			\
+	} while ( 0 )
+
+/**
+ * Perform TCP/IP self-tests
+ *
+ */
+static void tcpip_test_exec ( void ) {
+
+	tcpip_ok ( &empty );
+	tcpip_ok ( &one_byte );
+	tcpip_ok ( &two_bytes );
+	tcpip_ok ( &final_carry_big );
+	tcpip_ok ( &final_carry_little );
+	tcpip_random_ok ( &random_aligned );
+	tcpip_random_ok ( &random_unaligned_1 );
+	tcpip_random_ok ( &random_unaligned_2 );
+	tcpip_random_ok ( &random_aligned_truncated );
+	tcpip_random_ok ( &partial );
+}
+
+/** TCP/IP self-test */
+struct self_test tcpip_test __self_test = {
+	.name = "tcpip",
+	.exec = tcpip_test_exec,
+};
diff --git a/roms/ipxe/src/tests/test.c b/roms/ipxe/src/tests/test.c
new file mode 100644
index 0000000000000000000000000000000000000000..62f7c97d99b948c089ac200fce5cbe89a30a8aa7
--- /dev/null
+++ b/roms/ipxe/src/tests/test.c
@@ -0,0 +1,174 @@
+/*
+ * Copyright (C) 2011 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Self-test infrastructure
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stddef.h>
+#include <stdio.h>
+#include <errno.h>
+#include <assert.h>
+#include <ipxe/test.h>
+#include <ipxe/init.h>
+#include <ipxe/image.h>
+
+/** Current self-test set */
+static struct self_test *current_tests;
+
+/**
+ * Report test result
+ *
+ * @v success		Test succeeded
+ * @v file		Test code file
+ * @v line		Test code line
+ */
+void test_ok ( int success, const char *file, unsigned int line ) {
+
+	/* Sanity check */
+	assert ( current_tests != NULL );
+
+	/* Increment test counter */
+	current_tests->total++;
+
+	/* Report failure if applicable */
+	if ( ! success ) {
+		current_tests->failures++;
+		printf ( "FAILURE: \"%s\" test failed at %s line %d\n",
+			 current_tests->name, file, line );
+	}
+}
+
+/**
+ * Run self-test set
+ *
+ */
+static void run_tests ( struct self_test *tests ) {
+	unsigned int old_assertion_failures = assertion_failures;
+
+	/* Sanity check */
+	assert ( current_tests == NULL );
+
+	/* Record current test set */
+	current_tests = tests;
+
+	/* Run tests */
+	tests->exec();
+
+	/* Clear current test set */
+	current_tests = NULL;
+
+	/* Record number of assertion failures */
+	tests->assertion_failures =
+		( assertion_failures - old_assertion_failures );
+
+	/* Print test set summary */
+	if ( tests->failures || tests->assertion_failures ) {
+		printf ( "FAILURE: \"%s\" %d of %d tests failed",
+			 tests->name, tests->failures, tests->total );
+		if ( tests->assertion_failures ) {
+			printf ( " with %d assertion failures",
+				 tests->assertion_failures );
+		}
+		printf ( "\n" );
+	} else {
+		printf ( "OK: \"%s\" %d tests passed\n",
+			 tests->name, tests->total );
+	}
+}
+
+/**
+ * Run all self-tests
+ *
+ * @ret rc		Return status code
+ */
+static int run_all_tests ( void ) {
+	struct self_test *tests;
+	unsigned int failures = 0;
+	unsigned int assertions = 0;
+	unsigned int total = 0;
+
+	/* Run all compiled-in self-tests */
+	printf ( "Starting self-tests\n" );
+	for_each_table_entry ( tests, SELF_TESTS )
+		run_tests ( tests );
+
+	/* Print overall summary */
+	for_each_table_entry ( tests, SELF_TESTS ) {
+		total += tests->total;
+		failures += tests->failures;
+		assertions += tests->assertion_failures;
+	}
+	if ( failures || assertions ) {
+		printf ( "FAILURE: %d of %d tests failed",
+			 failures, total );
+		if ( assertions ) {
+			printf ( " with %d assertion failures", assertions );
+		}
+		printf ( "\n" );
+		return -EINPROGRESS;
+	} else {
+		printf ( "OK: all %d tests passed\n", total );
+		return 0;
+	}
+}
+
+static int test_image_probe ( struct image *image __unused ) {
+	return -ENOTTY;
+}
+
+static int test_image_exec ( struct image *image __unused ) {
+	return run_all_tests();
+}
+
+static struct image_type test_image_type = {
+	.name = "self-tests",
+	.probe = test_image_probe,
+	.exec = test_image_exec,
+};
+
+static struct image test_image = {
+	.refcnt = REF_INIT ( ref_no_free ),
+	.name = "<TESTS>",
+	.type = &test_image_type,
+};
+
+static void test_init ( void ) {
+	int rc;
+
+	/* Register self-tests image */
+	if ( ( rc = register_image ( &test_image ) ) != 0 ) {
+		DBG ( "Could not register self-test image: %s\n",
+		      strerror ( rc ) );
+		/* No way to report failure */
+		return;
+	}
+}
+
+/** Self-test initialisation function */
+struct init_fn test_init_fn __init_fn ( INIT_EARLY ) = {
+	.initialise = test_init,
+};
